#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>

#include "utils.h"

void dispatchTasks() {

    int taskId = 0;
    while (1) {

        struct task *curTask = (struct task *)malloc(sizeof(struct task));
        curTask -> taskId = taskId;
        curTask -> nextTask = NULL;
        curTask -> fileIndex = fileIndexer -> fileIndex;
        curTask -> fileCursor = fileIndexer -> fileCursor;

        struct result *curResult = (struct result *)malloc(sizeof(struct result));
        curResult -> charArray = (unsigned char *)malloc(sizeof(unsigned char) * CHUNKSIZE);
        curResult -> countArray = (uint8_t *)malloc(sizeof(uint8_t) * CHUNKSIZE);
        curResult -> resultLength = 0;
        curResult -> prevResult = NULL;
        curResult -> nextResult = NULL;
        curTask -> result = curResult;
        
        pthread_mutex_lock(&taskQueueAccess);
        if (firstTask == NULL) {
            firstTask = curTask;
            lastTask = curTask;
        }
        else {
            lastTask -> nextTask = curTask;
            lastTask = curTask;
        }
        if (firstResult == NULL) {
            firstResult = curTask -> result;
            lastResult = firstResult;
            pthread_cond_signal(&taskInQueue);
        }
        else {
            lastResult -> nextResult = curTask -> result;
            lastResult = curTask -> result;
        }
        if (DEBUG) fprintf(stderr, "task %d enqueued\n", curTask -> taskId);
        pthread_mutex_unlock(&taskQueueAccess);
        
        if (fileIndexer -> fileCursor + CHUNKSIZE >= fileLengths[fileIndexer -> fileIndex]) {
            if (fileIndexer -> fileIndex >= fileCount - 1) {
                break;
            }
            fileIndexer -> fileIndex ++;
            fileIndexer -> fileCursor = 0;
        }
        else {
            fileIndexer -> fileCursor += CHUNKSIZE;
        }
        taskId ++;

    }

}
